//
//  Terminal.h
//  tys-terminal-app
//
//  Created by AR'S Chino Mac 1 on 11/9/16.
//  Copyright © 2016 Taiyo Yuden. All rights reserved.
//

#ifndef __Terminal_H_
#define __Terminal_H_

#import <UIKit/UIKit.h>
@import CoreBluetooth;

@interface Terminal : UIViewController <UITableViewDelegate, UITableViewDataSource, CBPeripheralDelegate, UITextFieldDelegate, UIActionSheetDelegate>

@property (strong, nonatomic) CBPeripheral *peripheral;

/**
*   Numeric format enumerators [Hex, Ascii]
*/
typedef enum {
    Fmt_Ascii,
    Fmt_Hex,
} format_t;

/**
*   End of line character selection enumerators
*/
typedef enum {
    EOL_NONE,
    EOL_CR,
    EOL_LF,
    EOL_CRLF,
} eol_t;

// Macros to return string representation
#define format2str(enum) (NSString*)[@[@"Ascii",@"Hex"] objectAtIndex:enum]
#define eol2str(enum) [@[@"None",@"CR",@"LF",@"CRLF"] objectAtIndex:enum]

- (BOOL)writeMessageToPeripheral:(NSString *)string;
- (void)printMessageToScreen:(NSString *)message characteristic:(CBCharacteristic *)characteristic;
- (void)clearScreen;
- (NSData *) ascii2hex: (NSData*) message;
- (NSData *) hex2string:(NSData *)message;
- (char) getValidHex:(char) b;
@end

#endif
